function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';

import PropTypes from 'prop-types';
import BoardDrawer from './board-drawer.js';

// Board draw's a Go Board
var Board = function (_React$PureComponent) {
  _inherits(Board, _React$PureComponent);

  function Board(props) {
    _classCallCheck(this, Board);

    var _this = _possibleConstructorReturn(this, _React$PureComponent.call(this, props));

    var size = props.size,
        width = props.width,
        height = props.height;


    _this.drawer = new BoardDrawer(size, width, height);
    return _this;
  }

  Board.prototype.componentDidMount = function componentDidMount() {
    var _props = this.props,
        moves = _props.moves,
        width = _props.width,
        height = _props.height;

    var context = this.canvas.getContext('2d');

    this.canvas.width = width;
    this.canvas.height = height;

    if (context) {
      this.context = context;
      this.drawer.draw(this.context, moves);
    }
  };

  Board.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var moves = nextProps.moves;


    if (this.context) {
      this.drawer.draw(this.context, moves);
    }
  };

  Board.prototype.render = function render() {
    var _this2 = this;

    return React.createElement('canvas', { ref: function ref(c) {
        return _this2.canvas = c;
      } });
  };

  return Board;
}(React.PureComponent);

Board.propTypes = {
  width: PropTypes.number.isRequired,
  height: PropTypes.number.isRequired,
  size: PropTypes.number,
  moves: PropTypes.arrayOf(PropTypes.shape({
    color: PropTypes.oneOf(['B', 'W'])
  }))
};

Board.defaultProps = {
  size: 19,
  moves: []
};

export default Board;