'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _boardDrawer = require('./board-drawer.js');

var _boardDrawer2 = _interopRequireDefault(_boardDrawer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Board draw's a Go Board
var Board = function (_React$PureComponent) {
  _inherits(Board, _React$PureComponent);

  function Board(props) {
    _classCallCheck(this, Board);

    var _this = _possibleConstructorReturn(this, _React$PureComponent.call(this, props));

    var size = props.size,
        width = props.width,
        height = props.height;


    _this.drawer = new _boardDrawer2.default(size, width, height);
    return _this;
  }

  Board.prototype.componentDidMount = function componentDidMount() {
    var _props = this.props,
        moves = _props.moves,
        width = _props.width,
        height = _props.height;

    var context = this.canvas.getContext('2d');

    this.canvas.width = width;
    this.canvas.height = height;

    if (context) {
      this.context = context;
      this.drawer.draw(this.context, moves);
    }
  };

  Board.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var moves = nextProps.moves;


    if (this.context) {
      this.drawer.draw(this.context, moves);
    }
  };

  Board.prototype.render = function render() {
    var _this2 = this;

    return _react2.default.createElement('canvas', { ref: function ref(c) {
        return _this2.canvas = c;
      } });
  };

  return Board;
}(_react2.default.PureComponent);

Board.propTypes = {
  width: _propTypes2.default.number.isRequired,
  height: _propTypes2.default.number.isRequired,
  size: _propTypes2.default.number,
  moves: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    color: _propTypes2.default.oneOf(['B', 'W'])
  }))
};

Board.defaultProps = {
  size: 19,
  moves: []
};

exports.default = Board;